oe-buildenv-internal 4.4 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131
  1. #!/bin/sh
  2. # OE-Core Build Environment Setup Script
  3. #
  4. # Copyright (C) 2006-2011 Linux Foundation
  5. #
  6. # This program is free software; you can redistribute it and/or modify
  7. # it under the terms of the GNU General Public License as published by
  8. # the Free Software Foundation; either version 2 of the License, or
  9. # (at your option) any later version.
  10. #
  11. # This program is distributed in the hope that it will be useful,
  12. # but WITHOUT ANY WARRANTY; without even the implied warranty of
  13. # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
  14. # GNU General Public License for more details.
  15. #
  16. # You should have received a copy of the GNU General Public License
  17. # along with this program; if not, write to the Free Software
  18. # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
  19. if ! $(return >/dev/null 2>&1) ; then
  20. echo 'oe-buildenv-internal: error: this script must be sourced'
  21. echo ''
  22. echo 'Usage: . $OEROOT/scripts/oe-buildenv-internal &&'
  23. echo ''
  24. echo 'OpenEmbedded oe-buildenv-internal - an internal script that is'
  25. echo 'used in oe-init-build-env to initialize oe build environment'
  26. echo ''
  27. exit 2
  28. fi
  29. # It is assumed OEROOT is already defined when this is called
  30. if [ -z "$OEROOT" ]; then
  31. echo >&2 "Error: OEROOT is not defined!"
  32. return 1
  33. fi
  34. if [ -z "$OE_SKIP_SDK_CHECK" ] && [ -n "$OECORE_SDK_VERSION" ]; then
  35. echo >&2 "Error: The OE SDK/ADT was detected as already being present in this shell environment. Please use a clean shell when sourcing this environment script."
  36. return 1
  37. fi
  38. py_v27_check=$(python2 -c 'import sys; print sys.version_info >= (2,7,3)')
  39. if [ "$py_v27_check" != "True" ]; then
  40. echo >&2 "OpenEmbedded requires 'python' to be python v2 (>= 2.7.3), not python v3."
  41. echo >&2 "Please upgrade your python v2."
  42. fi
  43. unset py_v27_check
  44. # We potentially have code that doesn't parse correctly with older versions
  45. # of Python, and rather than fixing that and being eternally vigilant for
  46. # any other new feature use, just check the version here.
  47. py_v34_check=$(python3 -c 'import sys; print(sys.version_info >= (3,4,0))')
  48. if [ "$py_v34_check" != "True" ]; then
  49. echo >&2 "BitBake requires Python 3.4.0 or later as 'python3'"
  50. return 1
  51. fi
  52. unset py_v34_check
  53. if [ -z "$BDIR" ]; then
  54. if [ -z "$1" ]; then
  55. BDIR="build"
  56. else
  57. BDIR="$1"
  58. if [ "$BDIR" = "/" ]; then
  59. echo >&2 "Error: / is not supported as a build directory."
  60. return 1
  61. fi
  62. # Remove any possible trailing slashes. This is used to work around
  63. # buggy readlink in Ubuntu 10.04 that doesn't ignore trailing slashes
  64. # and hence "readlink -f new_dir_to_be_created/" returns empty.
  65. BDIR=$(echo $BDIR | sed -re 's|/+$||')
  66. BDIR=$(readlink -f "$BDIR")
  67. if [ -z "$BDIR" ]; then
  68. PARENTDIR=$(dirname "$1")
  69. echo >&2 "Error: the directory $PARENTDIR does not exist?"
  70. return 1
  71. fi
  72. fi
  73. if [ -n "$2" ]; then
  74. BITBAKEDIR="$2"
  75. fi
  76. fi
  77. if [ "${BDIR#/}" != "$BDIR" ]; then
  78. BUILDDIR="$BDIR"
  79. else
  80. BUILDDIR="$(pwd)/$BDIR"
  81. fi
  82. unset BDIR
  83. if [ -z "$BITBAKEDIR" ]; then
  84. BITBAKEDIR="$OEROOT/bitbake$BBEXTRA"
  85. test -d "$BITBAKEDIR" || BITBAKEDIR="$OEROOT/../bitbake$BBEXTRA"
  86. fi
  87. BITBAKEDIR=$(readlink -f "$BITBAKEDIR")
  88. BUILDDIR=$(readlink -f "$BUILDDIR")
  89. BBPATH=$BUILDDIR
  90. export BBPATH
  91. if [ ! -d "$BITBAKEDIR" ]; then
  92. echo >&2 "Error: The bitbake directory ($BITBAKEDIR) does not exist! Please ensure a copy of bitbake exists at this location or specify an alternative path on the command line"
  93. return 1
  94. fi
  95. # Make sure our paths are at the beginning of $PATH
  96. for newpath in "$BITBAKEDIR/bin" "$OEROOT/scripts"; do
  97. # Remove any existences of $newpath from $PATH
  98. PATH=$(echo $PATH | sed -re "s#(^|:)$newpath(:|$)#\2#g;s#^:##")
  99. # Add $newpath to $PATH
  100. PATH="$newpath:$PATH"
  101. done
  102. unset BITBAKEDIR newpath
  103. # Used by the runqemu script
  104. export BUILDDIR
  105. export PATH
  106. BB_ENV_EXTRAWHITE_OE="MACHINE DISTRO TCMODE TCLIBC HTTP_PROXY http_proxy \
  107. HTTPS_PROXY https_proxy FTP_PROXY ftp_proxy FTPS_PROXY ftps_proxy ALL_PROXY \
  108. all_proxy NO_PROXY no_proxy SSH_AGENT_PID SSH_AUTH_SOCK BB_SRCREV_POLICY \
  109. SDKMACHINE BB_NUMBER_THREADS BB_NO_NETWORK PARALLEL_MAKE GIT_PROXY_COMMAND \
  110. SOCKS5_PASSWD SOCKS5_USER SCREENDIR STAMPS_DIR BBPATH_EXTRA BB_SETSCENE_ENFORCE"
  111. BB_ENV_EXTRAWHITE="$(echo $BB_ENV_EXTRAWHITE $BB_ENV_EXTRAWHITE_OE | tr ' ' '\n' | LC_ALL=C sort --unique | tr '\n' ' ')"
  112. export BB_ENV_EXTRAWHITE